﻿<UserControl x:Class="HiVE.MsgBoxSelector_Demo_WPF.isUserControl.MsgBoxSelector_Construct"
             x:ClassModifier="internal"
             xmlns="http://schemas.microsoft.com/winfx/2006/xaml/presentation"
             xmlns:x="http://schemas.microsoft.com/winfx/2006/xaml"
             xmlns:mc="http://schemas.openxmlformats.org/markup-compatibility/2006" 
             xmlns:d="http://schemas.microsoft.com/expression/blend/2008" 
             xmlns:local="clr-namespace:HiVE.MsgBoxSelector_Demo_WPF.isUserControl"
             xmlns:basicModels_isConverter="clr-namespace:HiVE.BasicModels.isConverter;assembly=HiVE.BasicModels"
             mc:Ignorable="d"
             Name="msgBoxSelector_Construct"
             MinWidth="320" MinHeight="240">

    <UserControl.Resources>
        <basicModels_isConverter:Converter_BooleanToScrollBarVisibility x:Key="Converter_BooleanToScrollBarVisibility"/>
        <basicModels_isConverter:Converter_BooleanToVisibility x:Key="Converter_BooleanToVisibility"/>
        <basicModels_isConverter:Converter_BooleanToInverse x:Key="Converter_BooleanToInverse"/>
        <basicModels_isConverter:Converter_BooleanToWrapOrWrapWithOverflow x:Key="Converter_BooleanToWrapOrWrapWithOverflow"/>

        <DataTemplate x:Key="ColorItemTemplate">
            <StackPanel Orientation="Horizontal">
                <Rectangle Fill="{Binding Path=HashCode}"
                           Width="30" Height="20"
                           VerticalAlignment="Center"
                           Stroke="Black"
                           StrokeThickness="1"/>
                <TextBlock Text="{Binding Path=Name}"
                           FontSize="14"
                           VerticalAlignment="Center"
                           Margin="5,0,0,0"/>
            </StackPanel>
        </DataTemplate>
    </UserControl.Resources>

    <ScrollViewer HorizontalScrollBarVisibility="Auto"
                  VerticalScrollBarVisibility="Auto">
        <Grid HorizontalAlignment="Stretch"
              VerticalAlignment="Stretch">
            <Grid.RowDefinitions>
                <RowDefinition Height="Auto"/>
                <RowDefinition Height="*"/>
                <RowDefinition Height="Auto"/>
            </Grid.RowDefinitions>

            <StackPanel Name="stackPanelMain" Grid.Row="0"
                        Orientation="Vertical"
                        HorizontalAlignment="Center"
                        VerticalAlignment="Stretch"
                        Margin="5">

                <DockPanel LastChildFill="False"
                           HorizontalAlignment="Stretch"
                           VerticalAlignment="Center">
                    <TextBlock Text="Message:"
                               DockPanel.Dock="Left"
                               VerticalAlignment="Center" />
                    <CheckBox Name="checkBoxMessageWrapping"
                              Content="Message Wrap"
                              DockPanel.Dock="Right"
                              VerticalAlignment="Center"
                              IsChecked="True"/>
                </DockPanel>

                <TextBox Name="textBoxMessage"
                         Text="Message information!"
                         TextWrapping="{Binding ElementName=checkBoxMessageWrapping, Path=IsChecked, Converter={StaticResource Converter_BooleanToWrapOrWrapWithOverflow}}"
                         AcceptsReturn="True"
                         MinWidth="480" MaxHeight="200"
                         MaxWidth="{Binding ElementName=stackPanelMain, Path=ActualWidth}"
                         HorizontalAlignment="Stretch"
                         HorizontalScrollBarVisibility="Auto"
                         VerticalScrollBarVisibility="Auto"/>

                <DockPanel LastChildFill="False"
                           HorizontalAlignment="Stretch"
                           VerticalAlignment="Center">
                    <TextBlock Text="Caption:"
                               DockPanel.Dock="Left"
                               VerticalAlignment="Center" />
                    <CheckBox Name="checkBoxCustomCaption"
                              Content="Custom Caption"
                              DockPanel.Dock="Right"
                              VerticalAlignment="Center"
                              Checked="checkBoxCustomCaption_Checked"
                              Unchecked="checkBoxCustomCaption_Unchecked"/>
                </DockPanel>
                <ComboBox Name="comboBoxMsgBoxMethodCaption"
                          Text="Window caption!"
                          AutomationProperties.HelpText="Window caption!"
                          IsEnabled="{Binding ElementName=checkBoxCustomCaption, Path=IsChecked, Converter={StaticResource Converter_BooleanToInverse}}"
                          SelectionChanged="comboBoxMsgBoxMethodCaption_SelectionChanged"
                          Loaded="comboBoxMsgBoxMethodCaption_Loaded"/>
                <TextBox Name="textBoxCustomCaption"
                         Text="Window caption!"
                         Visibility="{Binding ElementName=checkBoxCustomCaption, Path=IsChecked, Converter={StaticResource Converter_BooleanToVisibility}}"/>

                <DockPanel LastChildFill="False"
                           HorizontalAlignment="Stretch"
                           VerticalAlignment="Center">
                    <TextBlock Text="MsgBoxMethodButtons: Array of possible answers!"
                               DockPanel.Dock="Left"
                               VerticalAlignment="Center" />
                    <CheckBox Name="checkBoxCustomButtons"
                              Content="Custom Buttons"
                              DockPanel.Dock="Right"
                              VerticalAlignment="Center"
                              Checked="checkBoxCustomButtons_Checked"
                              Unchecked="checkBoxCustomButtons_Unchecked"/>
                </DockPanel>
                <ComboBox Name="comboBoxMsgBoxMethodButtons"
                          Text="Array of possible answers!"
                          AutomationProperties.HelpText="Array of possible answers!"
                          IsEnabled="{Binding ElementName=checkBoxCustomButtons, Path=IsChecked, Converter={StaticResource Converter_BooleanToInverse}}"
                          SelectionChanged="comboBoxMsgBoxMethodButtons_SelectionChanged"
                          Loaded="comboBoxMsgBoxMethodButtons_Loaded"/>

                <TextBlock Text="Custom Buttons: Custom array of possible answers!"
                           Visibility="{Binding ElementName=checkBoxCustomButtons, Path=IsChecked, Converter={StaticResource Converter_BooleanToVisibility}}"/>
                <TextBox Name="textBoxCustomButtons"
                         Text="Each Line = One Button!"
                         Margin="2"
                         TextWrapping="Wrap"
                         AcceptsReturn="True"
                         MinWidth="480" MaxHeight="120"
                         HorizontalScrollBarVisibility="Auto"
                         VerticalScrollBarVisibility="Auto"
                         Visibility="{Binding ElementName=checkBoxCustomButtons, Path=IsChecked, Converter={StaticResource Converter_BooleanToVisibility}}"/>

                <DockPanel LastChildFill="False"
                           HorizontalAlignment="Stretch"
                           VerticalAlignment="Center">
                    <TextBlock Text="MsgBoxMethodIcon: Image to be displayed as the message icon!"
                               DockPanel.Dock="Left"
                               VerticalAlignment="Center" />
                    <CheckBox Name="checkBoxCustomIcon"
                              Content="Custom Icon"
                              DockPanel.Dock="Right"
                              VerticalAlignment="Center"
                              Checked="checkBoxCustomIcon_Checked"
                              Unchecked="checkBoxCustomIcon_Unchecked"/>
                </DockPanel>
                <ComboBox Name="comboBoxMsgBoxMethodIcon"
                          Text="Image to be displayed as the message icon!"
                          AutomationProperties.HelpText="Image to be displayed as the message icon!"
                          IsEnabled="{Binding ElementName=checkBoxCustomIcon, Path=IsChecked, Converter={StaticResource Converter_BooleanToInverse}}"
                          SelectionChanged="comboBoxMsgBoxMethodIcon_SelectionChanged"
                          Loaded="comboBoxMsgBoxMethodIcon_Loaded"/>

                <TextBlock Text="Custom Icon: Custom image to be displayed as the message icon!"
                           Visibility="{Binding ElementName=checkBoxCustomIcon, Path=IsChecked, Converter={StaticResource Converter_BooleanToVisibility}}"/>
                <DockPanel LastChildFill="True"
                           Visibility="{Binding ElementName=checkBoxCustomIcon, Path=IsChecked, Converter={StaticResource Converter_BooleanToVisibility}}">
                    <Image Name="imageCustomIcon"
                           DockPanel.Dock="Left"
                           Margin="2,8"
                           Width="64" Height="64"
                           MaxWidth="64" MaxHeight="64"
                           Source="/Images/Logo.x512.ico"/>
                    <Button Name="buttonSelectCustomIcon"
                            Content="Select..."
                            DockPanel.Dock="Left"
                            Click="buttonSelectCustomIcon_Click"/>
                    <TextBox Name="textBlockCustomIconPath"
                             DockPanel.Dock="Left"
                             Margin="1"
                             HorizontalAlignment="Stretch"
                             VerticalAlignment="Center"
                             IsReadOnly="True" />
                </DockPanel>

                <TextBlock Text="MsgBoxMethodDefaultButton: Default answer zero-based index!"/>
                <ComboBox Name="comboBoxMsgBoxMethodDefaultButton"
                          Text="Default answer zero-based index!"
                          AutomationProperties.HelpText="Default answer zero-based index!"
                          Loaded="comboBoxMsgBoxMethodDefaultButton_Loaded"/>

                <TextBlock Text="MsgBoxMethodOptions:"/>
                <ComboBox Name="comboBoxMsgBoxMethodOptions"
                          Text="Options!"
                          AutomationProperties.HelpText="Options!"
                          Loaded="comboBoxMsgBoxMethodOptions_Loaded"/>

                <DockPanel LastChildFill="False"
                           HorizontalAlignment="Stretch"
                           VerticalAlignment="Center">
                    <TextBlock Text="MsgBoxMethodButtonsColors: Button colors!"
                               DockPanel.Dock="Left"
                               VerticalAlignment="Center" />
                    <CheckBox Name="checkBoxCustomButtonsColors"
                              Content="Custom Buttons Colors"
                              DockPanel.Dock="Right"
                              VerticalAlignment="Center"
                              Checked="checkBoxCustomButtonsColors_Checked"
                              Unchecked="checkBoxCustomButtonsColors_Unchecked"/>
                </DockPanel>
                <ComboBox Name="comboBoxMsgBoxMethodButtonsColors" Text="Button colors!"
                          AutomationProperties.HelpText="Button colors!"
                          IsEnabled="{Binding ElementName=checkBoxCustomButtonsColors, Path=IsChecked, Converter={StaticResource Converter_BooleanToInverse}}"
                          SelectionChanged="comboBoxMsgBoxMethodButtonsColors_SelectionChanged"
                          Loaded="comboBoxMsgBoxMethodButtonsColors_Loaded"/>

                <Grid Background="Gainsboro"
                      MaxHeight="275"
                      Visibility="{Binding ElementName=checkBoxCustomButtonsColors, Path=IsChecked, Converter={StaticResource Converter_BooleanToVisibility}}">
                    <Grid Margin="10">
                        <Grid.ColumnDefinitions>
                            <ColumnDefinition Width="10*"/>
                            <ColumnDefinition Width="10*"/>
                            <ColumnDefinition Width="10*"/>
                        </Grid.ColumnDefinitions>
                        <Grid.RowDefinitions>
                            <RowDefinition Height="Auto"/>
                            <RowDefinition Height="10*"/>
                        </Grid.RowDefinitions>

                        <TextBlock Text="Colors List Selected:"
                                   Grid.Row="0" Grid.Column="0"/>
                        <Border Grid.Row="1" Grid.Column="0"
                                Background="{Binding ElementName=listBoxColorsListSelected, Path=SelectedValue.HashCode}"
                                Padding="8"
                                HorizontalAlignment="Stretch"
                                VerticalAlignment="Stretch">
                            <ListBox Name="listBoxColorsListSelected"
                                     HorizontalAlignment="Stretch"
                                     MinWidth="220"
                                     ItemTemplate="{StaticResource ColorItemTemplate}"/>
                        </Border>

                        <StackPanel Name="stackPanelCustomButtonsColors"
                                    Orientation="Vertical"
                                    Grid.Row="1" Grid.Column="1"
                                    HorizontalAlignment="Center"
                                    VerticalAlignment="Center">
                            <Button Name="buttonAddColor"
                                    Content="Add Colors"
                                    Click="buttonAddColors_Click"/>

                            <TextBlock Text="Hash Code Color: #FF00AA99"
                                       Margin="1,20,1,1"
                                       HorizontalAlignment="Center"/>

                            <Grid Margin="20,2"
                                  HorizontalAlignment="Center">
                                <Grid.RowDefinitions>
                                    <RowDefinition/>
                                    <RowDefinition/>
                                </Grid.RowDefinitions>
                                <Grid.ColumnDefinitions>
                                    <ColumnDefinition Width="22"/>
                                    <ColumnDefinition Width="36"/>
                                    <ColumnDefinition Width="16"/>
                                    <ColumnDefinition Width="22"/>
                                    <ColumnDefinition Width="36"/>
                                </Grid.ColumnDefinitions>

                                <TextBlock Text="A"
                                           Grid.Row="0" Grid.Column="0"
                                           HorizontalAlignment="Right"
                                           Margin="2"/>
                                <TextBox Name="textBoxCustomColorA"
                                         Text="FF"
                                         Grid.Row="0" Grid.Column="1"
                                         MinWidth="30"
                                         Margin="1"
                                         TextAlignment="Center"
                                         MaxLength="2"/>

                                <TextBlock Text="R"
                                           Grid.Row="0" Grid.Column="3"
                                           HorizontalAlignment="Right"
                                           Margin="2"/>
                                <TextBox Name="textBoxCustomColorR"
                                         Text="00"
                                         Grid.Row="0" Grid.Column="4"
                                         MinWidth="30"
                                         Margin="1"
                                         TextAlignment="Center"
                                         MaxLength="2"/>

                                <TextBlock Text="G"
                                           Grid.Row="1" Grid.Column="0"
                                           HorizontalAlignment="Right"
                                           Margin="2"/>
                                <TextBox Name="textBoxCustomColorG"
                                         Text="AA"
                                         Grid.Row="1" Grid.Column="1"
                                         MinWidth="30"
                                         Margin="1"
                                         TextAlignment="Center"
                                         MaxLength="2"/>

                                <TextBlock Text="B"
                                           Grid.Row="1" Grid.Column="3"
                                           HorizontalAlignment="Right"
                                           Margin="2"/>
                                <TextBox Name="textBoxCustomColorB"
                                         Text="99"
                                         Grid.Row="1" Grid.Column="4"
                                         MinWidth="30"
                                         Margin="1"
                                         TextAlignment="Center"
                                         MaxLength="2"/>
                            </Grid>

                            <Button Name="buttonAddCustomColor"
                                    Content="Add Custom Color"
                                    Click="buttonAddCustomColor_Click"/>

                            <Button Name="buttonDeleteFromList"
                                    Content="Delete From List"
                                    Margin="2,20,2,2"
                                    Click="buttonDeleteFromList_Click"/>
                        </StackPanel>

                        <TextBlock Text="Colors List:"
                                   Grid.Row="0" Grid.Column="2"/>
                        <Border Grid.Row="1" Grid.Column="2"
                                Background="{Binding ElementName=listBoxColorsList, Path=SelectedValue.HashCode}"
                                Padding="8"
                                HorizontalAlignment="Stretch"
                                VerticalAlignment="Stretch">
                            <ListBox Name="listBoxColorsList"
                                     HorizontalAlignment="Stretch"
                                     MinWidth="220"
                                     ItemsSource="{Binding ElementName=msgBoxSelector_Construct, Path=Colors}"
                                     ItemTemplate="{StaticResource ColorItemTemplate}"/>
                        </Border>
                    </Grid>
                </Grid>

                <DockPanel LastChildFill="False"
                           HorizontalAlignment="Stretch"
                           VerticalAlignment="Center">
                    <TextBlock Text="MsgBoxMethodSilentBox: Silent check box; if None then check box will not be displayed!"
                               DockPanel.Dock="Left"
                               VerticalAlignment="Center" />
                    <CheckBox Name="checkBoxCustomSilentBox"
                              Content="Custom SilentBox"
                              DockPanel.Dock="Right"
                              VerticalAlignment="Center"
                              Checked="checkBoxCustomSilentBox_Checked"
                              Unchecked="checkBoxCustomSilentBox_Unchecked"/>
                </DockPanel>
                <ComboBox Name="comboBoxMsgBoxMethodSilentBox"
                          Text="Silent check box; if None then check box will not be displayed!"
                          AutomationProperties.HelpText="Silent check box; if None then check box will not be displayed!"
                          IsEnabled="{Binding ElementName=checkBoxCustomSilentBox, Path=IsChecked, Converter={StaticResource Converter_BooleanToInverse}}"
                          SelectionChanged="comboBoxMsgBoxMethodSilentBox_SelectionChanged"
                          Loaded="comboBoxMsgBoxMethodSilentBox_Loaded"/>

                <TextBlock Text="Custom SilentBox Text: Custom silent check box text; if null then check box will not be displayed!"
                           Visibility="{Binding ElementName=checkBoxCustomSilentBox, Path=IsChecked, Converter={StaticResource Converter_BooleanToVisibility}}"/>
                <TextBox Name="textBoxCustomSilentBox"
                         Text="Custom silent check box text; if null then check box will not be displayed!"
                         Visibility="{Binding ElementName=checkBoxCustomSilentBox, Path=IsChecked, Converter={StaticResource Converter_BooleanToVisibility}}"/>

                <TextBlock Text="Culture: Change culture and change design RTL or LTR!"/>
                <ComboBox Name="comboBoxMsgBoxMethodCulture"
                          Text="Change culture and change design RTL or LTR!"
                          AutomationProperties.HelpText="Change culture and change design RTL or LTR!"
                          Loaded="comboBoxMsgBoxMethodCulture_Loaded"/>

                <CheckBox Name="checkBoxShowHelp"
                          Content="Show Help!"
                          Margin="5,20,5,5"/>
            </StackPanel>

            <WrapPanel Grid.Row="2"
                       Orientation="Horizontal"
                       HorizontalAlignment="Center"
                       VerticalAlignment="Center"
                       Margin="10,20,10,10">
                <Button Name="buttonShow"
                        Content="Show MessageBox"
                        Click="buttonShow_Click"/>
            </WrapPanel>
        </Grid>
    </ScrollViewer>
</UserControl>
